package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.ColumnDataFeign;
import com.steerinfo.dil.model.TmstrainLoadingResult;
import com.steerinfo.dil.service.ITmstrainLoadingResultService;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstrainLoadingResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-30 02:23
 * 类描述
 * 修订历史：
 * 日期：2021-08-30
 * 作者：generator
 * 参考：
 * 描述：TmstrainLoadingResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tmstrainloadingresults")
public class TmstrainLoadingResultController extends BaseRESTfulController {

    @Autowired
    ITmstrainLoadingResultService tmstrainLoadingResultService;

    @Autowired
    ColumnDataFeign columnDataFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value="查询装车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(58)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTmstrainWagonLoad")
    public RESTfulResult getTmstrainWagonLoad(@RequestBody(required=false) Map<String,Object> mapValue,
                                              Integer apiId,
                                              Integer pageNum,
                                              Integer pageSize){

        List<Map<String, Object>> tmstrainWagonLoad = tmstrainLoadingResultService.getTmstrainWagonLoad(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        List<Map<String, Object>> tmstrainWagonLoad1 = tmstrainLoadingResultService.getTmstrainWagonLoad(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, tmstrainWagonLoad,tmstrainWagonLoad1);
        return success(pageList);
    }

    /**
     * 新增车皮装车作业实绩
     * @param tmstrainLoadingResult
     * @return
     */
    @ApiOperation(value="新增车皮装车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainLoadingResult", value = "车皮装车对象", required = false, dataType = "TmstrainLoadingResult")
    })
    @PostMapping(value = "/insertTmstrainLoadingResult")
    public RESTfulResult insertTmstrainLoadingResult(@RequestBody(required = false) TmstrainLoadingResult tmstrainLoadingResult){

        int i = tmstrainLoadingResultService.addTmstrainLoadingResult(tmstrainLoadingResult);
        return success(i);
    }

    /**
     * 通过主键查询车皮装车作业信息
     * @param resultId
     * @return
     */
    @ApiOperation(value="通过主键查询车皮装车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "车皮装车主键", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/getTmstrainLoadingResultByResultId/{resultId}")
    public RESTfulResult getTmstrainLoadingResultByResultId(@PathVariable("resultId") BigDecimal resultId){
        List<Map<String, Object>> loadingResultByResultId = tmstrainLoadingResultService.getTmstrainLoadingResultByResultId(resultId);
        System.out.println(loadingResultByResultId);
        return success(loadingResultByResultId);
    }

    /**
     * 通过主键修改车皮装车作业实绩
     * @param tmstrainLoadingResult
     * @return
     */
    @ApiOperation(value="通过主键修改车皮装车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainLoadingResult", value = "修改车皮装车map", required = false, dataType = "TmstrainWagonLoadResult")
    })
    @PostMapping(value = "/upadteTmstrainLoadingResultByResultId")
    public RESTfulResult upadteTmstrainLoadingResultByResultId(@RequestBody(required = false) TmstrainLoadingResult tmstrainLoadingResult){
        int i = tmstrainLoadingResultService.updateTmstrainLoadingResult(tmstrainLoadingResult);
        return success(i);
    }

    /**
     * 通过主键删除车皮装车作业实绩
     * @param resultId
     * @return
     */
    @ApiOperation(value="通过主键删除车皮装车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "主键ID", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/deleteTmstrainLoadingResultByResultId")
    public RESTfulResult deleteTmstrainLoadingResultByResultId(@RequestParam BigDecimal resultId){
        int i = tmstrainLoadingResultService.deleteTmstrainLoadingResultByResultId(resultId);
        return success(i);
    }

    /**
     * 获取发站地点名称
     * @param
     * @return
     */
    @ApiOperation(value="获取发站地点名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getSendStationName")
    public RESTfulResult getSendStationName(){

        return success(tmstrainLoadingResultService.getSendStationName());
    }

    /**
     * 获取到站地点名称
     * @param
     * @return
     */
    @ApiOperation(value="获取到站地点名称")
    @GetMapping(value = "/getArrivalStationName")
    public RESTfulResult getArrivalStationName(){
        return success(tmstrainLoadingResultService.getArrivalStationName());
    }

    /**
     * 获取批次ID
     * @param
     * @return
     */
    @ApiOperation(value="获取批次ID")
    @GetMapping(value = "/getBatchId")
    public RESTfulResult getBatchId(){
        return success(tmstrainLoadingResultService.getBatchId());
    }

    /**
     * 获取装车车皮号
     * @param
     * @return
     */
    @ApiOperation(value="获取装车车皮号")
    @GetMapping(value = "/getWagonNo")
    public RESTfulResult getWagonNo(){
        return success(tmstrainLoadingResultService.getWagonNo());
    }
}
