package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstrainLoadingResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstrainLoadingResultMapper extends IBaseMapper<TmstrainLoadingResult, BigDecimal> {
    //查询所有装车作业信息
    List<Map<String, Object>> getTmsWagonLoadInfo(Map<String,Object> map);

    //查询主键最大值
    @Select("select seq_tmstrian_loading.nextval from dual")
    BigDecimal selectMaxId();

    //获取外轮船名
    String getResultForeignShipName(BigDecimal batchId);
    //获取物资ID
    BigDecimal getMaterialID(BigDecimal batchId);
    //获得采购订单id
    BigDecimal getPurchaseOrderId(BigDecimal batchId);
    //获得发站地点名称
    List<Map<String, Object>> getSendStationName();
    //获得到站地点名称
    List<Map<String, Object>> getArrivalStationName();
    //获得批次ID
    List<Map<String, Object>> getBatchId();
    //获得装车车皮号
    List<Map<String, Object>> getWagonNo();
    //获得要渲染的数据
    List<Map<String, Object>> selectByResultId(BigDecimal ResultId);
    //通过发站ID查询所属港口ID
    BigDecimal getPortIdBySendStationId(BigDecimal sendStationId);
}