package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="车皮装车作业")
public class TmstrainWagonLoadResult implements IBasePO<BigDecimal> {
    /**
     * 主键ID(LOADING_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal loadingId;

    /**
     * 采购订单ID(PURCHASE_ORDER_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="采购订单ID",required=false)
    private BigDecimal purchaseOrderId;

    /**
     * 车皮号(WAGON_NO,VARCHAR,20)
     */
    @ApiModelProperty(value="车皮号",required=false)
    private String wagonNo;

    /**
     * 计费吨位(LOADING_BILLABLE_TONNAGE,DECIMAL,0)
     */
    @ApiModelProperty(value="计费吨位",required=false)
    private Short loadingBillableTonnage;

    /**
     * 班别（0:白班，1：夜班）(RESULT_CLASS,VARCHAR,20)
     */
    @ApiModelProperty(value="班别（0:白班，1：夜班）",required=false)
    private String resultClass;

    /**
     * 装车时间(LOADING_WAGON_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="装车时间",required=false)
    private Date loadingWagonTime;

    /**
     * 备注(LOADING_REMARK,VARCHAR,20)
     */
    @ApiModelProperty(value="备注",required=false)
    private String loadingRemark;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 品名(PRODUCT_NAME,VARCHAR,36)
     */
    @ApiModelProperty(value="品名",required=false)
    private String productName;

    /**
     * 发站ID(SEND_STATION_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="发站ID",required=false)
    private Short sendStationId;

    /**
     * 到站ID(ARRIVAL_STATION_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="到站ID",required=false)
    private Short arrivalStationId;

    /**
     * 是否删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="是否删除",required=false)
    private Short deleted;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.loadingId;
    }

    @Override
    public void setId(BigDecimal loadingId) {
        this.loadingId = loadingId;
    }

    public BigDecimal getLoadingId() {
        return loadingId;
    }

    public void setLoadingId(BigDecimal loadingId) {
        this.loadingId = loadingId;
    }

    public BigDecimal getPurchaseOrderId() {
        return purchaseOrderId;
    }

    public void setPurchaseOrderId(BigDecimal purchaseOrderId) {
        this.purchaseOrderId = purchaseOrderId;
    }

    public String getWagonNo() {
        return wagonNo;
    }

    public void setWagonNo(String wagonNo) {
        this.wagonNo = wagonNo == null ? null : wagonNo.trim();
    }

    public Short getLoadingBillableTonnage() {
        return loadingBillableTonnage;
    }

    public void setLoadingBillableTonnage(Short loadingBillableTonnage) {
        this.loadingBillableTonnage = loadingBillableTonnage;
    }

    public String getResultClass() {
        return resultClass;
    }

    public void setResultClass(String resultClass) {
        this.resultClass = resultClass == null ? null : resultClass.trim();
    }

    public Date getLoadingWagonTime() {
        return loadingWagonTime;
    }

    public void setLoadingWagonTime(Date loadingWagonTime) {
        this.loadingWagonTime = loadingWagonTime;
    }

    public String getLoadingRemark() {
        return loadingRemark;
    }

    public void setLoadingRemark(String loadingRemark) {
        this.loadingRemark = loadingRemark == null ? null : loadingRemark.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName == null ? null : productName.trim();
    }

    public Short getSendStationId() {
        return sendStationId;
    }

    public void setSendStationId(Short sendStationId) {
        this.sendStationId = sendStationId;
    }

    public Short getArrivalStationId() {
        return arrivalStationId;
    }

    public void setArrivalStationId(Short arrivalStationId) {
        this.arrivalStationId = arrivalStationId;
    }

    public Short getDeleted() {
        return deleted;
    }

    public void setDeleted(Short deleted) {
        this.deleted = deleted;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", loadingId=").append(loadingId);
        sb.append(", purchaseOrderId=").append(purchaseOrderId);
        sb.append(", wagonNo=").append(wagonNo);
        sb.append(", loadingBillableTonnage=").append(loadingBillableTonnage);
        sb.append(", resultClass=").append(resultClass);
        sb.append(", loadingWagonTime=").append(loadingWagonTime);
        sb.append(", loadingRemark=").append(loadingRemark);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", productName=").append(productName);
        sb.append(", sendStationId=").append(sendStationId);
        sb.append(", arrivalStationId=").append(arrivalStationId);
        sb.append(", deleted=").append(deleted);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}