package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.TmstrainPleaseApproveResultMapper;
import com.steerinfo.dil.model.TmstrainPleaseApproveResult;
import com.steerinfo.dil.service.ITmstrainPleaseApproveResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * TmstrainPleaseApproveResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-30 02:09
 * 类描述
 * 修订历史：
 * 日期：2021-08-30
 * 作者：generator
 * 参考：
 * 描述：TmstrainPleaseApproveResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstrainPleaseApproveResultService")
public class TmstrainPleaseApproveResultServiceImpl implements ITmstrainPleaseApproveResultService {

    @Autowired
    private TmstrainPleaseApproveResultMapper tmstrainPleaseApproveResultMapper;


    /**
     * 查询所有未下发请车计划
     * @param mapValue
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllWagonPlease(Map<String, Object> mapValue) {
        return tmstrainPleaseApproveResultMapper.getAllWagonPlease(mapValue);
    }

    /**
     * 获取最大主键ID
     * @return
     */
    @Override
    public BigDecimal selectMaxId() {
        return tmstrainPleaseApproveResultMapper.selectMaxId();
    }

    /**
     * 新增请车作业
     * @param tmstrainPleaseApproveResult 请车批车实绩
     * @return
     */
    @Override
    public int insertSelective(TmstrainPleaseApproveResult tmstrainPleaseApproveResult) {
        //生成主键ID

        BigDecimal maxId = selectMaxId();
        long id = maxId.longValue();
        tmstrainPleaseApproveResult.setResultId(maxId);
        //设置状态 新增的为未下发状态
        tmstrainPleaseApproveResult.setStatus(new BigDecimal(0));
        //生成请车计划号
        String resultPleasePlanNo;
        if(id >= 100){
            resultPleasePlanNo = "WQCJH-" + id;
        }else if(id >= 10) {
            resultPleasePlanNo = "WQCJH-0" + id;
        }else {
            resultPleasePlanNo = "WQCJH-00" + id;
        }
        tmstrainPleaseApproveResult.setResultPleasePlanNo(resultPleasePlanNo);
        //生成请车日期
        tmstrainPleaseApproveResult.setResultPleaseDate(new Date());
        return tmstrainPleaseApproveResultMapper.insertSelective(tmstrainPleaseApproveResult);
    }

    /**
     * 修改、下发、删除请车作业  修改、删除批车作业
     * @param tmstrainPleaseApproveResult
     * @return
     */
    @Override
    public int updateByPrimaryKeySelective(TmstrainPleaseApproveResult tmstrainPleaseApproveResult) {
        return tmstrainPleaseApproveResultMapper.updateByPrimaryKeySelective(tmstrainPleaseApproveResult);
    }

    /**
     * 查询所有批车作业
     * @param mapValue
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllApproveWagonPlease(Map<String, Object> mapValue) {
        return tmstrainPleaseApproveResultMapper.getAllApproveWagonPlease(mapValue);
    }

    /**
     * 通过ID查询批车作业
     * @param resultId
     * @return
     */
    @Override
    public List<Map<String, Object>> getApproveWagonPleaseById(Integer resultId) {
        return tmstrainPleaseApproveResultMapper.getApproveWagonPleaseById(resultId);
    }

    /**
     * 通过Id查询请车作业 用于修改
     * @return
     */
    @Override
    public List<Map<String, Object>> getWagonPleaseById(Integer resultId) {
        return tmstrainPleaseApproveResultMapper.getWagonPleaseById(resultId);
    }
    /**
     * 获取收货单位
     * @return
     */
    @Override
    public List<Map<String, Object>> getShipper() {
        return tmstrainPleaseApproveResultMapper.getShipper();
    }

    /**
     * 获取发运计划
     * @return
     */
    @Override
    public List<Map<String, Object>> getRailPlan() {
        return tmstrainPleaseApproveResultMapper.getRailPlan();
    }



}
