package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.TmstrainWagonUnloadResultMapper;
import com.steerinfo.dil.model.TmstrainWagonUnloadResult;
import com.steerinfo.dil.service.ITmstrainWagonUnloadResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * TmstrainWagonUnloadResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 09:22
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmstrainWagonUnloadResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstrainWagonUnloadResultService")
public class TmstrainWagonUnloadResultServiceImpl implements ITmstrainWagonUnloadResultService {

    @Autowired
    private TmstrainWagonUnloadResultMapper tmstrainWagonUnloadResultMapper;

    @Override
    public List<Map<String, Object>> getTmstrainWagonUnLoad(Map<String, Object> map) {
        return tmstrainWagonUnloadResultMapper.getTmsWagonUnLoadInfo(map);
    }

    @Override
    public int deleteTmstrainWagonUnLoadResultByUnLoadingId(BigDecimal unloadingId) {
        TmstrainWagonUnloadResult tmstrainWagonUnloadResult = tmstrainWagonUnloadResultMapper.selectByPrimaryKey(unloadingId);
        tmstrainWagonUnloadResult.setDeleted(new BigDecimal(1));
        return tmstrainWagonUnloadResultMapper.updateByPrimaryKeySelective(tmstrainWagonUnloadResult);
    }

    @Override
    public int addTmstrainWagonLoadResult(TmstrainWagonUnloadResult tmstrainWagonUnloadResult) {
        //生成主键id
        tmstrainWagonUnloadResult.setUnloadingId(tmstrainWagonUnloadResultMapper.selectMaxId());
        //通过装车车皮号得到并插入采购订单id
        BigDecimal purchaseOrderId = tmstrainWagonUnloadResultMapper.getPurchaseOrderId(tmstrainWagonUnloadResult.getResultWagonNo());
        tmstrainWagonUnloadResult.setPurchaseOrderRailPlanId(purchaseOrderId);
        //常规字段插入
        tmstrainWagonUnloadResult.setInsertUsername("admin");
        tmstrainWagonUnloadResult.setInsertTime(new Date());
        tmstrainWagonUnloadResult.setUpdateUsername("admin");
        tmstrainWagonUnloadResult.setUpdateTime(new Date());
        tmstrainWagonUnloadResult.setInsertUpdateRemark("无");
        tmstrainWagonUnloadResult.setDeleted(new BigDecimal(0));
        return tmstrainWagonUnloadResultMapper.insert(tmstrainWagonUnloadResult);
    }

    @Override
    public int updateTmstrainWagonUnLoadResult(TmstrainWagonUnloadResult tmstrainWagonUnloadResult) {
        tmstrainWagonUnloadResult.setUpdateTime(new Date());
        return tmstrainWagonUnloadResultMapper.updateByPrimaryKeySelective(tmstrainWagonUnloadResult);
    }

    @Override
    public List<Map<String, Object>> getTmstrainResult(Map<String, Object> map) {
        return tmstrainWagonUnloadResultMapper.getTmstrainResult(map);
    }

    @Override
    public List<Map<String, Object>> getUnloadingPointName() {
        return tmstrainWagonUnloadResultMapper.getUnloadingPointName();
    }

    @Override
    public List<Map<String, Object>> getUnloadingRouteName() {
        return tmstrainWagonUnloadResultMapper.getUnloadingRouteName();
    }

    @Override
    public List<Map<String, Object>> getTmstrainWagonUnLoadResultByUnLoadingId(BigDecimal unloadingId) {
        return tmstrainWagonUnloadResultMapper.selectByUnLoadingId(unloadingId);
    }
}
