package com.steerinfo.dil.util;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/8/25 11:25
 */

public class DataChange {

    /**
     * 解析前端传来的日期字符串
     * @param vueDate
     * @return
     */
    public static Date dataToDate(Object vueDate){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date parseDate = null;
        if (vueDate != null){
            try {
                String date = (String) vueDate;
                parseDate = sdf.parse(date);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
        return parseDate;
    }

    /**
     * 数据转换成BigDecimal
     * @param data
     * @return
     */
    public static BigDecimal dataToBigDecimal(Object data){
        if (data != null){
            if(data instanceof String){
                String data1 = (String) data;
                return new BigDecimal(data1);
            }
            if(data instanceof Integer){
                Integer data2 = (Integer) data;
                return new BigDecimal(data2);
            }
            if(data instanceof Double){
                Double data3 = (Double) data;
                return new BigDecimal(data3);
            }
            if(data instanceof BigDecimal){
                return (BigDecimal) data;
            }
        }
        return new BigDecimal(0);
    }

    /**
     * 将时间截取到天  为字符串类型 用于前端只显示到天
     * @param date 传入时间
     * @return
     */
    public static String dateToDayDate(Object date){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date changeDate = null;
        try{
             changeDate = (Date) date;
        }catch (Exception e){
            e.printStackTrace();
        }
        return sdf.format(changeDate);
    }

    /**
     * 遍历从数据库中传进来的数据
     * @param list 从数据库查询出来的list数据列表
     * @param key map中多个需要转换的date参数
     */
    public static void changeDateToDayDate(List<Map<String, Object>> list, String ...key){
        //遍历List
        for (Map<String, Object> map : list) {
            for (String s : key) {
                //从map中取 date的值 并转换成字符串类型的日期
                String stringDate = dateToDayDate(map.get(s));
                if(stringDate.length() == 0){
                    break;
                }else {
                    //修改map中的值
                    map.put(s, stringDate);
                }
            }
        }
    }
}
